%define releasebase 10 
%define nickname Morrison Hotel
#Use as deafults if no command line inputs
%define as_gnu4 1 
%define as_limulus 1 
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu3: %{expand: %%define as_gnu3 1}}
%{?_with_gnu4: %{expand: %%define as_gnu4 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
# If we are building for a gnu3 distro, we need
# convert all the -gnu4 refernces to -gnu3:
%if "1" == "%{as_basement}"
%define nbase basement-doc
%define targetbase Basement 
%else
%if "1" == "%{as_limulus}"
%define nbase limulus-doc
%define targetbase Limulus
%endif
%endif

%if "1" == "%{as_gnu3}"
Name: %{nbase}-gnu3
%else
%if "1" == "%{as_gnu4}"
Name: %{nbase}-gnu4
%endif
%endif

Summary:Cluster Documentation
Version:1.1
Group: %{targetbase}/Documentation
Release: %{releasebase}.%{targetbase}
License: Copyright 2007-2012 Basement Supercomputing
Source:  bsc-doc-%{version}.tgz
URL: www.basement-supercomputing.com
Distribution: Scientific Linux
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Vendor: Basement Supercomputing
Packager: deadline@basement-supercomputing.com
%define ver %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
Requires: modules

#If these libararies are installed, then include them (set 0 to 1)
%define include_acml 0 
%define include_mkl 0

%description
Documentation for Basement Supercomputing Baselinei/Limulus Cluster Suite
%prep 
%setup -n bsc-doc-%{version}

%build
# put together the libarary page
cd libraries
cat start.part.template >libraries.html
%if "1" == "%{include_acml}"
cat acml.part >>libraries.html
%else
sed "s!<LI><a href=\"#amdlibs\">AMD ACML</a> - AMD Core Math Library</li>!!g"  libraries.html > 2.html
cp 2.html libraries.html
/bin/rm 2.html
%endif
%if "1" == "%{include_mkl}"
cat mkl.part >>libraries.html
%else
sed "s!<LI><a href=\"#intellibs\">Intel MKL</a> - Intel Math Kernel Library</li>!!g"  libraries.html > 3.html
cp 3.html libraries.html
/bin/rm 3.html
%endif
cat end.part >>libraries.html
cp libraries.html libraries.html.template

cd ..
#fix all the gnu3/4 stuff
%if "1" == "%{as_gnu3}"
#These files reference gnu(3,4) 
fix="index.html.template \
sge/SGE.html.template \
mpi/README.lam \
mpi/README.mpich \
mpi/README.mpich2 \
mpi/README.mpichgm \
mpi/README.ompi \
Compiling/Compiling_Programs.html.template \
compile-libs-examples/atlas-C/Makefile \
compile-libs-examples/atlas-Fortran/Makefile \
compile-libs-examples/fftw2/Makefile \
compile-libs-examples/fftw3/Makefile \
compile-libs-examples/fftpack/Makefile \
compile-libs-examples/lapack-C++/Makefile \
compile-libs-examples/lapack-C/Makefile \
compile-libs-examples/lapack-Fortran/Makefile \
libraries/libraries.html.template"
for i in $fix
do
 /bin/cp $i   $i.install
 sed "s!gnu4!gnu3!g"  $i.install >  $i
 /bin/rm  $i.install
done

# change gfortran to g77
fix=" compile-libs-examples/fftw2/Makefile \
compile-libs-examples/fftw3/Makefile \
compile-libs-examples/fftpack/Makefile \
compile-libs-examples/lapack-C++/Makefile \
compile-libs-examples/lapack-C/Makefile \
compile-libs-examples/lapack-Fortran/Makefile \
compile-libs-examples/atlas-C/Makefile \
compile-libs-examples/atlas-Fortran/Makefile \
compile-libs-examples/Fortran/Makefile \
compile-libs-examples/C/Makefile \
compile-libs-examples/acml-C/Makefile \
compile-libs-examples/acml-Fortran/Makefile \
compile-libs-examples/mkl-C/Makefile \
compile-libs-examples/mkl-Fortran/Makefile  \
compile-libs-examples/Goto-C/Makefile \
compile-libs-examples/Goto-Fortran/Makefile \
compile-libs-examples/openBLAS-C/Makefile \
compile-libs-examples/openBLAS-Fortran/Makefile \
Compiling/Compiling_Programs.html "

for i in $fix
do
 /bin/cp $i   $i.install
 sed "s!gfortran!g77!g"  $i.install >  $i
 /bin/cp $i   $i.install
 sed "s!G77!g77!g"  $i.install >  $i
 /bin/cp $i   $i.install
 sed "s!Gfortran!gfortran!g"  $i.install >  $i
 /bin/rm  $i.install
done
%endif
#
%if "1" == "%{as_basement}"
cp images/bsc-275x52.png images/logo.png
%define where www
%else
%if "1" == "%{as_limulus}"
cp images/limulus_175x114.png images/logo.png
%define where limulus
%endif
%endif

fix="index.html 
bps-logs/index.html \
Compiling/Compiling_Programs.html \
How-Do-I/How-Do-I.html    \
monitor-test/montior-test.html \
sge/SGE.html \
libraries/libraries.html "

for i in $fix
do
 sed 's!_NAME_!%{targetbase}!g'  $i.template | sed 's!_WHERE_!%{where}!g' \
| sed 's!_VER_!%{version}-%{releasebase} %{nickname}!g' >  $i
done


# gt rid of any .bak and .part files
/bin/rm `find . -name "*.bak" -print`
/bin/rm `find . -name "*.part" -print`

%install
mkdir -p  %{buildroot}/etc/httpd/conf.d
cp limulus.conf %{buildroot}/etc/httpd/conf.d/
mkdir -p  %{buildroot}/usr/share/doc/%{nbase}
%if "1" == "%{as_basement}"
cp README.Basement   %{buildroot}/usr/share/doc/%{nbase}
%else
cp README.HPC.Limulus   %{buildroot}/usr/share/doc/%{nbase}
%endif
cp favicon.ico   %{buildroot}/usr/share/doc/%{nbase}
cp index.html   %{buildroot}/usr/share/doc/%{nbase}
cp simple.css  %{buildroot}/usr/share/doc/%{nbase}
cp -R images  %{buildroot}/usr/share/doc/%{nbase}
cp -R mpi  %{buildroot}/usr/share/doc/%{nbase}
cp -R sge  %{buildroot}/usr/share/doc/%{nbase}
cp -R licenses  %{buildroot}/usr/share/doc/%{nbase}
cp -R compile-libs-examples  %{buildroot}/usr/share/doc/%{nbase}
cp -R libraries  %{buildroot}/usr/share/doc/%{nbase}
cp -R How-Do-I  %{buildroot}/usr/share/doc/%{nbase}
cp -R bps-logs  %{buildroot}/usr/share/doc/%{nbase}
cp -R Compiling  %{buildroot}/usr/share/doc/%{nbase}
cp -R ganglia  %{buildroot}/usr/share/doc/%{nbase}
cp -R monitor-test  %{buildroot}/usr/share/doc/%{nbase}
cp -R pvm-book  %{buildroot}/usr/share/doc/%{nbase}
cp -R scripts  %{buildroot}/usr/share/doc/%{nbase}
find  %{buildroot}/usr/share/doc/%{nbase} -name "*.templat*" -exec rm -rf {} \;
%post
/etc/rc.d/init.d/httpd reload &> /dev/null
%postun
if [ $1 -eq 0 ] ; then
  /etc/rc.d/init.d/httpd reload &> /dev/null
fi
%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
#%defattr(-,root,root)
/usr/share/doc/%{nbase}/*
/etc/httpd/conf.d/limulus.conf
